//
// Computergraphik I
// Prof. Dr. Juergen Doellner
// Sommersemester 2001
// 
// Rahmenprogramm zu Aufgabenzettel 7
//

#include "vector.h"
#include <math.h>
#include <string.h>

bool Vector::operator<(const Vector& u) const {
    return((v_[0]<u.v_[0]) ||
           (v_[0]==u.v_[0] && v_[1]<u.v_[1]) ||
           (v_[0]==u.v_[0] && v_[1]==u.v_[1] && v_[2]<u.v_[2])
    );
}

Vector& Vector::operator*=(const Vector& u) { // cross product
    double x = v_[0];
    double y = v_[1];
    double z = v_[2];
    v_[0] = y*u.v_[2] - z*u.v_[1];
    v_[1] = z*u.v_[0] - x*u.v_[2];
    v_[2] = x*u.v_[1] - y*u.v_[0];
    return *this;
}

Vector Vector::normalized() const {
    double L = sqrt(v_[0]*v_[0] + v_[1]*v_[1] + v_[2]*v_[2]);
    if(fabs(L) == 0.0) {
        return Vector(0,0,0);
    } else {
        return Vector(v_[0]/L, v_[1]/L, v_[2]/L);
    }
}

bool Vector::normalize() {
    double L = sqrt(v_[0]*v_[0] + v_[1]*v_[1] + v_[2]*v_[2]);
    if(fabs(L) == 0.0) {
        return false;
    } else {
        v_[0] /= L;
        v_[1] /= L;
        v_[2] /= L;
        return true;
    }
}

//
// IO
//

ostream& operator<<(ostream& s, const Vector& u) {
    s << u[0] << " " << u[1] << " " << u[2];
    return s;
}

istream& operator>>(istream& s, Vector& u) {

    s >> u[0];
    if(!s.good()) { return s; }
   
    s >> u[1];
    if(!s.good()) { return s; }

    s >> u[2];
    if(!s.good()) { return s; }

    return s;
}